#include <stdio.h>
#include <string.h>
#include <SDL/SDL.h>
#include <SDL/SDL_mixer.h>

#define WIDTH 640
#define HEIGHT 480

int quitapp(Mix_Music *music) {
	Mix_FreeMusic(music);
	Mix_CloseAudio();
	SDL_Quit();
	exit(0);
}

int putpixel(SDL_Surface *scr, int x, int y, int c) {
        ((unsigned int *)scr->pixels)[y*scr->w+x]=c;
        return 0;
}

int main(int argc,char *argv[]) {
	SDL_Surface *scr;
	SDL_Event event;
	
	char modname[10];
	if (argc>1) {
		strcpy(modname,argv[1]);
	} else {
		fprintf(stdout,"Ussage: %s module\n",argv[0]);
	        exit(1);
	}
	
	if (SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO)<0) {
                fprintf(stderr,"SDL_Init error: %s\n",SDL_GetError());
                exit(2);
        }
        atexit(SDL_Quit);
        if ((scr=SDL_SetVideoMode(WIDTH,HEIGHT,32,SDL_SWSURFACE))==NULL) {
                fprintf(stderr,"SDL_SetVideoMode error: %s\n",SDL_GetError());
                exit(2);
        }
	SDL_WM_SetCaption("SDLwindow - Module music test",NULL);

	
	Mix_Music *music;
	if (Mix_OpenAudio(22050, MIX_DEFAULT_FORMAT, 2, 2048) == -1) {
                printf("Mix_OpenAudio error: %s\n", Mix_GetError());
                exit(3);
        }
        Mix_AllocateChannels(1);
        if ((music = Mix_LoadMUS(modname)) == NULL) {
                printf("Mix_LoadMUS error: %s\n", Mix_GetError());
		exit(3);
	}

        Mix_PlayMusic(music, 1);/* 1 = opakovat*/

	int tick,x,y;
	while (1) {
		/* tento efekt je opsn ze sady pklad z SOL's SDL tutorial*/
		tick=SDL_GetTicks();
		for (y=0;y<scr->h;y++) {
			for (x=0;x<scr->w;x++) {
				putpixel(scr,x,y,x*x+y*y+tick);
			}
		}
		
	
		SDL_Flip(scr);
		
                while (SDL_PollEvent(&event)) {
                        switch (event.type) {
                                case SDL_KEYDOWN:
					if (event.key.keysym.sym==SDLK_SPACE) {
						if (Mix_PausedMusic()) {
							Mix_ResumeMusic();
						} else {
							Mix_PauseMusic();
						}
						
					}
					break;
				case SDL_KEYUP:
                                        if (event.key.keysym.sym==SDLK_f) {
                                                SDL_WM_ToggleFullScreen(scr);
                                        }
					if (event.key.keysym.sym==SDLK_ESCAPE) {
						quitapp(music);
					}
                                        break;
                                case SDL_QUIT:
					quitapp(music);
					break;
                                       
			}
		}
	}
	return 0;
}
