#include <stdio.h>
#include <string.h>
#include <SDL/SDL.h>

#include "sdlpal.h"

#define WIDTH 320
#define HEIGHT 200

int putpixel(SDL_Surface *scr, int x, int y, int c) {
        ((unsigned int *)scr->pixels)[y*scr->w+x]=c;
        return 0;
}

int main(int argc,char *argv[]) {
	SDL_Surface *scr;

        char palfile[50];
	
	if (argc>1) {
		strcpy(palfile,argv[1]);
	} else {
		fprintf(stdout,"Ussage: %s pallete\n",argv[0]);
		exit(1);
	}
	
	SDL_Color *pal;
        int ncolors;
	pal=readpalette(palfile,&ncolors);
	double koef=256/ncolors;
        if (SDL_Init(SDL_INIT_VIDEO)<0) {
                fprintf(stderr,"Unable to init SDL:%s\n",SDL_GetError());
                return 1;
        }
        atexit(SDL_Quit);
        scr=SDL_SetVideoMode(WIDTH,HEIGHT,32,SDL_SWSURFACE);
        SDL_WM_SetCaption("SDLplasma",NULL);
        if (scr==NULL) {
                fprintf(stderr,"Unable to set videomode: %s\n",SDL_GetError());
                return 1;
        }

	unsigned char ft[512],sint[256],a,b,d,c,od,col;
	unsigned int x,y,i;

	for (i=0;i<512;i++) {
		ft[i]=(int)(64+63*sin(i/40.74)+cos(i/40.74));
	}
	for (i=0;i<256;i++) {
		sint[i]=(int)(64+63*cos(i/40.74)+sin(i/40.74));
	}

	c=od=0;
	while (1) {
		c-=2;
		od+=1;
		d=od;
		for (y=1;y<HEIGHT;y++) {
			d+=2;
			a=sint[(c+y) & 255];
			b=sint[d & 255];
			for (x=0;x<WIDTH;x++) {
				col=ft[a+b]+ft[y+b];
				putpixel(scr,x,y,convcolor(pal[(int)(col/koef)]));
				a+=(1+col/128);
				b+=1;
			}
		}
		SDL_UpdateRect(scr,0,0,WIDTH,HEIGHT);
		SDL_Event event;
                while (SDL_PollEvent(&event)) {
                        switch (event.type) {
                                case SDL_KEYDOWN:
                                        break;
                                case SDL_KEYUP:
                                        if (event.key.keysym.sym==SDLK_ESCAPE) {
                                                return 0;
                                        }
                                        if (event.key.keysym.sym==SDLK_f) {
                                                SDL_WM_ToggleFullScreen(scr);
                                        }
                                        break;
                                case SDL_QUIT:
                                        return 0;
			}
		}
	}
	return 0;
}
