#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <SDL/SDL.h>

#define WIDTH 640
#define HEIGHT 480
#define SPEED 3

int putpixel(SDL_Surface *scr, int x, int y, int c) {
        ((unsigned int *)scr->pixels)[y*(scr->pitch/4)+x]=c;
        return 0;
}

int showsurface(SDL_Surface *scr,SDL_Surface *img,int x,int y) {
	SDL_Rect rct;
	
	SDL_UnlockSurface(scr);
	rct.x=x;
	rct.y=y;
	rct.w=img->w;
	rct.h=img->h;
	
	if (SDL_BlitSurface(img,NULL,scr,&rct)<0) {
		fprintf(stderr,"SDL_BlitSurfaceError: %s\n",SDL_GetError());
		return 1;
	}

	SDL_LockSurface(scr);
	SDL_UpdateRect(img,0,0,img->w,img->h);
	return 0;
}
	
int main() {
	SDL_Surface *scr;
	SDL_Event event;

	if (SDL_Init(SDL_INIT_VIDEO)<0) {
                fprintf(stderr,"SDL_Init error: %s\n",SDL_GetError());
                exit(2);
        }
        atexit(SDL_Quit);
        if ((scr=SDL_SetVideoMode(WIDTH,HEIGHT,32,SDL_SWSURFACE))==NULL) {
                fprintf(stderr,"SDL_SetVideoMode error: %s\n",SDL_GetError());
                exit(2);
        }
        SDL_WM_SetCaption("SDLwindow - BMP picture test",NULL);
	
	SDL_Surface *obrazek;
	obrazek=SDL_LoadBMP("moon.bmp");
	SDL_SetColorKey(obrazek,SDL_SRCCOLORKEY,0);
	
	srand(time(NULL));
	int x,y,opx,opy,spx,spy,i,j;
	x=(WIDTH/2)-(obrazek->w/2);
	y=(HEIGHT/2)-(obrazek->h/2);
	opx=1;
	opy=1;
	spx=rand()%2+SPEED;
	spy=rand()%2+SPEED;

	while (1) {
		x+=spx*opx;
		y+=spy*opy;
		if (x>(WIDTH-obrazek->w)) {
			opx=-1;
			spx=rand()%2+SPEED;
		}
		if (y>(HEIGHT-obrazek->h)) {
			opy=-1;
			spy=rand()%2+SPEED;
		}
		if (y<1) {
			opy=1;
			spy=rand()%2+SPEED;
		}
		if (x<1) {
			opx=1;
			spx=rand()%2+SPEED;
		}
		showsurface(scr,obrazek,x,y);
		
		SDL_UpdateRect(scr,0,0,WIDTH,HEIGHT);
                while (SDL_PollEvent(&event)) {
                        switch (event.type) {
                                case SDL_KEYDOWN:
                                        break;
                                case SDL_KEYUP:
                                        if (event.key.keysym.sym==SDLK_f) {
                                                SDL_WM_ToggleFullScreen(scr);
                                        }
					if (event.key.keysym.sym==SDLK_ESCAPE) {
						SDL_FreeSurface(obrazek);
						SDL_Quit();
						return 0;
					}
                                        break;
                                case SDL_QUIT:
					SDL_FreeSurface(obrazek);
					SDL_Quit();
					return 0;
                                       
			}
		}
	}
	return 0;
}
