#include <stdio.h>
#include <string.h>
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>

#define WIDTH 640
#define HEIGHT 480

int quitapp(TTF_Font *font) {
	TTF_CloseFont(font);
	TTF_Quit();
	SDL_Quit();
	exit(0);
}

int putpixel(SDL_Surface *scr, int x, int y, int c) {
        ((unsigned int *)scr->pixels)[y*(scr->pitch/4)+x]=c;
        return 0;
}

int printtext(SDL_Surface *scr, TTF_Font *font, int x, int y,char *chr, int c) {
	SDL_Surface *surf;
	SDL_Rect rect;
	SDL_Color col,col2;
	col.r=(c/65536)%256;
	col.g=(c/256)%256;
	col.b=c%256;
	surf=TTF_RenderText_Solid(font,chr,col);
	rect.x=x;
	rect.y=y;
	rect.w=surf->w;
	rect.h=surf->h;
	SDL_BlitSurface(surf,NULL,scr,&rect);
	SDL_FreeSurface(surf);
	return 0;
}
	
int main(int argc,char *argv[]) {
	SDL_Surface *scr;
	SDL_Event event;

        char fontname[50],*message="Hello, World!";
	if (argc>1) {
		strcpy(fontname,argv[1]);
	} else {
		fprintf(stdout,"Ussage: %s ttffont\n",argv[0]);
	        exit(1);
	}
	
	
	if (SDL_Init(SDL_INIT_VIDEO)<0) {
                fprintf(stderr,"SDL_Init error: %s\n",SDL_GetError());
                exit(1);
        }
        atexit(SDL_Quit);
        if ((scr=SDL_SetVideoMode(WIDTH,HEIGHT,32,SDL_SWSURFACE))==NULL) {
                fprintf(stderr,"SDL_SetVideoMode error: %s\n",SDL_GetError());
                exit(1);
        }
	SDL_WM_SetCaption("SDLwindow - TTF font test",NULL);

	TTF_Font *font;
	
	if (TTF_Init()) {
		 fprintf(stderr,"TTF_Init error: %s\n",TTF_GetError());
		 exit(2);
	}
	if ((font=TTF_OpenFont(fontname,30))==NULL) {
                 fprintf(stderr,"TTF_OpenFont error: %s\n",TTF_GetError());
                 exit(2);
	}

	while (1) {
		printtext(scr,font,1,1,message,0x00ff00);
		
		SDL_Flip(scr);
		
                while (SDL_PollEvent(&event)) {
                        switch (event.type) {
                                case SDL_KEYDOWN:
                                        break;
                                case SDL_KEYUP:
                                        if (event.key.keysym.sym==SDLK_f) {
                                                SDL_WM_ToggleFullScreen(scr);
                                        }
					if (event.key.keysym.sym==SDLK_s) {
						SDL_SaveBMP(scr,"shot.bmp");
					}
					if (event.key.keysym.sym==SDLK_ESCAPE) {
						quitapp(font);
					}
                                        break;
                                case SDL_QUIT:
					quitapp(font);
					break;
                                       
			}
		}
	}
	return 0;
}
